--- Makefile.in
+++ Makefile.in
@@ -17,7 +17,7 @@ libmagic @LIBMAGIC@:
 	@MAKE_MAGIC@ all
 
 textonly: contrib/textonly.c
-	$(CC) $(CFLAGS) -o textonly $<
+	$(CC) $(CFLAGS) $(LDFLAGS) -o textonly $<
 
 mpp: magic.m4 mkmpp
 	@srcdir@/mkmpp magic.m4
@@ -43,47 +43,46 @@ magic.c: magic.m4 mkmagic config.h
 cfmagic: file/magic
 	@MAKE_MAGIC@ magic
 
-commoninstall: textonly @CFMAGIC@
-	@INSTALL_DIR@ $(prefix)/@exedir@
-	@INSTALL_DIR@ $(prefix)/@mandir@/man8
-	@INSTALL_DIR@ $(prefix)/@mandir@/man5
-	@INSTALL_DIR@ $(prefix)/@filterdir@
-	@INSTALL_MAGIC@ -m 444 file/magic $(prefix)/@MAGIC@
-	@INSTALL_PROGRAM@ -m 511 textonly $(prefix)/@filterdir@
+commoninstall: textonly
+	@INSTALL_DIR@ $(DESTDIR)$(prefix)/@exedir@
+	@INSTALL_DIR@ $(DESTDIR)$(prefix)/@mandir@/man8
+	@INSTALL_DIR@ $(DESTDIR)$(prefix)/@mandir@/man5
+	@INSTALL_DIR@ $(DESTDIR)$(prefix)/@filterdir@
+	@INSTALL_PROGRAM@ textonly $(DESTDIR)$(prefix)/@filterdir@
 
 install:  @DO_WHAT@
 
 install-bin-t: traditional commoninstall
-	@INSTALL_PROGRAM@ -m 511 traditional $(prefix)/@exedir@/magicfilter-t
+	@INSTALL_PROGRAM@ traditional $(DESTDIR)$(prefix)/@exedir@/magicfilter-t
 
 install-bin: magicfilter commoninstall
-	@INSTALL_PROGRAM@ -m 511 magicfilter $(prefix)/@exedir@
+	@INSTALL_PROGRAM@ magicfilter $(DESTDIR)$(prefix)/@exedir@
 
 install-data-t: traditional commoninstall
 	@srcdir@/mkmpp
 	for x in @srcdir@/filters/*.def;do \
-	    ./mpp @exedir@/magicfilter-t $$x > $(prefix)/@filterdir@/`basename $$x .def`-filter; \
-	    chmod +x $(prefix)/@filterdir@/`basename $$x .def`-filter; \
+	    ./mpp @exedir@/magicfilter-t $$x > $(DESTDIR)$(prefix)/@filterdir@/`basename $$x .def`-filter; \
+	    chmod +x $(DESTDIR)$(prefix)/@filterdir@/`basename $$x .def`-filter; \
 	done
 	@rm -f mpp
 
 install-data: magicfilter commoninstall
 	for x in @srcdir@/filters/*.def;do \
-	    sed -e 's,@MAGIC''FILTER@,@exedir@/magicfilter,' < $$x > $(prefix)/@filterdir@/`basename $$x .def`; \
-	    chmod +x $(prefix)/@filterdir@/`basename $$x .def`; \
+	    sed -e 's,@MAGIC''FILTER@,@exedir@/magicfilter,' < $$x > $(DESTDIR)$(prefix)/@filterdir@/`basename $$x .def`; \
+	    chmod +x $(DESTDIR)$(prefix)/@filterdir@/`basename $$x .def`; \
 	done
 
 install-man: VERSION commoninstall
 	@SED@ -n -e 's/&PROGRAM&/magicfilter/g' -e 's/^MAN //p' -e @LPD_OPTS@ < magicfilter.8templ > $$$$; \
-	@INSTALL_DATA@ -m 444 $$$$ $(prefix)/@mandir@/man8/magicfilter.8; \
+	@INSTALL_DATA@ $$$$ $(DESTDIR)$(prefix)/@mandir@/man8/magicfilter.8; \
 	rm -f $$$$
-	@INSTALL_DATA@ -m 444 magicfilter.5 $(prefix)/@mandir@/man5
+	@INSTALL_DATA@ magicfilter.5 $(DESTDIR)$(prefix)/@mandir@/man5
 
 install-man-t: VERSION commoninstall
 	@SED@ -n -e 's/&PROGRAM&/magicfilter-t/g' -e 's/^MAN //p' -e 's/^TRAD//p' -e @LPD_OPTS@ < magicfilter.8templ > $$$$; \
-	@INSTALL_DATA@ -m 444 $$$$ $(prefix)/@mandir@/man8/magicfilter-t.8; \
+	@INSTALL_DATA@ $$$$ $(DESTDIR)$(prefix)/@mandir@/man8/magicfilter-t.8; \
 	rm -f $$$$
-	@INSTALL_DATA@ -m 444 magicfilter-t.5 $(prefix)/@mandir@/man5
+	@INSTALL_DATA@ magicfilter-t.5 $(DESTDIR)$(prefix)/@mandir@/man5
 
 install-traditional: install-man-t install-bin-t install-data-t
 
